/*
 * OOoPresentationContents.java
 *
 * Created on 13 juni 2006, 20:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package nl.reeven.van.nljug.ooo;

/**
 *
 * @author wouter_r
 */
public class OOoPresentationContents {
    
    // Some contents of the presentation
    public final String TOC_TITLE = "Table of Contents";
    public final String[] TOC = {"A short history of OOo","UNO: Unified Network Objects","The Java API/Code Examples"};
    public final String[] HISTORY = {"mid 1980's: StarDivision is founded",
                "summer of 1999: Sun Microsystem acquires StarDivision",
                "June 2000: StarOffice 5.2 released under GPL",
                "October 2000: First release of OOo",
                "September 2001: OOo 1.0 SDK released",
                "July 2002: Wouter joins StarOffice support team (providing support on Linux only by the way)",
                "September 2003: OOo 1.1 released",
                "Februari 2005: Wouter leaves Sun to join AMIS",
                "November 2005: OOo 2.0 released"};
    public final String[] UNO_OVERVIEW = {"Environment for network objects across programming languages and platforms",
                "Specified in an abstract meta language, called UNOIDL",
                "Uses a factory called the service manager",
                "Provides bridges to send method calls and receive return values between processes and between objects " + 
                "written in different implementation languages",
                "Most objects of OpenOffice.org are able to communicate in a UNO environment"};
    public final String[] UNO_API = {"OOo API is a language independent approach to specify the functionality of OOo",
                "Access the functionality of OOo",
                "Extend the functionality by own solutions and new features",
                "Available for",
                "Java",
                "C++",
                "OOo Basic",
                "MS Automation Bridge",
                "Common Language Infrastructure (.Net)",
                "Python"};
    public final String[] UNO_API_CONSISTS = {"OOo API consists of",
                "Data types",
                "e.g. void, boolean, double, any",
                "Interfaces",
                "single-inheritance and multiple-inheritance",
                "Services",
                "high-level multiple-inheritance interfaces",
                "Structs",
                "\"class without methods\"",
                "Modules",
                "similar to namespaces in C++ or packages in Java",
                "Exceptions",
                "Singletons"};
    public final String[] UNO_API_DRAWBACKS = {"API drawbacks:",
                "No one-to-one relationship between a certain service specification and a real object",
                "It is impossible to comprehend fully from the API reference what a given instance of an object in OOo is capable of",
                "There are several entry points where object implementations are actually available",
                "Old-style and new-style implementations",
                "Consequently, it is sometimes confusing to look up a needed functionality in the API reference"};
    public final String[] UNO_API_WORKFLOW = {"Basic workflow",
                "Start OOo either locally or remotely",
                "Connect to OOo instance",
                "Request static UnoRuntime environment through ServiceManage",
                "Request XComponent by querying the static UnoRuntime environment for the needed interface or setting Properties",
                "Get access to text, pages, shapes etc. by querying the UnoRuntime environment for the needed interfaces or setting Properties",
                "Save/print/convert document and close it",
                "Closing the connection to OOo will shut OOo down "};
    public final String[] JAVA_LOCAL_CONNECTION = {"Creating a local connection",
                "XComponentContext xRemoteContext = Bootstrap.bootstrap();",
                "XMultiComponentFactory xRemoteServiceManager = xRemoteContext.getServiceManager();",
                "Object desktop = xRemoteServiceManager.createInstanceWithContext(\"com.sun.star.frame.Desktop\", xRemoteContext);"};
    public final String[] JAVA_REMOTE_CONNECTION = {"Creating a remote connection",
                "XComponentContext xLocalContext = com.sun.star.comp.helper.Bootstrap.createInitialComponentContext( null );",
                "XMultiComponentFactory xLocalServiceManager = xLocalContext.getServiceManager();",
                "Object urlResolver = xLocalServiceManager.createInstanceWithContext( \"com.sun.star.bridge.UnoUrlResolver\", xLocalContext );",
                "XUnoUrlResolver xUrlResolver = (XUnoUrlResolver) UnoRuntime.queryInterface(XUnoUrlResolver.class, urlResolver );",
                "Object initialObject = xUrlResolver.resolve( \"uno:socket,host=localhost,port=2002;urp;StarOffice.ServiceManager\" );",
                "XPropertySet xPropertySet = (XPropertySet) UnoRuntime.queryInterface( XPropertySet.class, initialObject );",
                "Object context = xPropertySet.getPropertyValue( \"DefaultContext\" );",
                "XComponentContext xRemoteContext = (XComponentContext) UnoRuntime.queryInterface( XComponentContext.class, context );",
                "XMultiComponentFactory mxRemoteServiceManager = xRemoteContext.getServiceManager();",
                "Object desktop = mxRemoteServiceManager.createInstanceWithContext( \"com.sun.star.frame.Desktop\", null );"};
    public final String[] JAVA_REMOTE_SERVER = {"OOo server is started with",
                "soffice -accept=socket,host=0,port=2002;urp;",
                "or",
                "soffice -accept=socket,host=0,port=2002;urp; -invisible",
                "Connection is closed when not used anymore, remote counterpart crashes or the connection fails. Use XEventListener to detect closing connection."};
    public final String[] JAVA_LOAD_DOCUMENT = {"Documents are created or loaded using",
                "XComponentLoader xComponentLoader = (XComponentLoader)UnoRuntime.queryInterface(XComponentLoader.class, desktop);",
                "PropertyValue[] pPropValues = new PropertyValue[0];",
                "XComponent document = xComponentLoader.loadComponentFromURL(templateURL, \"_blank\", 0, pPropValues);",
                "Here templateURL is either URL to file or one of",
                "private:factory/swriter",
                "private:factory/scalc",
                "private:factory/sdraw",
                "private:factory/simpress"};
    public final String JAVA_DEMO = "DEMO";
    public final String[] JAVA_TEXT_DOCUMENTS = {"Text Documents",
                "Text",
                "e.g. paragraphs ",
                "Service Manager (document internal) ",
                "e.g. text tables, text fields, drawing shapes, text frames",
                "Draw Page ",
                "for images so text can wrap around them",
                "Text Content Suppliers ",
                "provide access to texts in Text and Service Manager",
                "Objects for styling and numbering "};

    /**
     * Creates a new instance of OOoPresentationContents
     */
    public OOoPresentationContents() {
    }
    
}
