/*
 * ConnectToOOo.java
 *
 * Created on 23 mei 2006, 10:49
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package nl.reeven.van.nljug.presentation;

import com.sun.star.beans.PropertyValue;
import com.sun.star.beans.XPropertySet;
import com.sun.star.bridge.XUnoUrlResolver;
import com.sun.star.comp.helper.Bootstrap;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.lang.XComponent;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.text.XTextDocument;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;

/**
 *
 * @author wouter_r
 */
public class ConnectToOOo {
    
    private static String docLocation = "file:///C:/OOoPresentation/Numbering.doc";
    
    /**
     * Creates a new instance of ConnectToOOo
     */
    public ConnectToOOo() {
    }

    public static void main(String[] args) {
        ConnectToOOo openExistingDoc = new ConnectToOOo();
        openExistingDoc.openDocument();
    }
    
    public void openDocument(){
        try {
            //Object desktop = getLocalDesktop();
            
            // If we want to use the line below instead of above, open a DOS prompt,
            // cd to <oo base>\program and give this command
            // soffice.bin -accept=socket,host=0,port=2002;urp;
            
            Object desktop = remoteConnect("0", "2002");
            XComponentLoader xComponentLoader = (XComponentLoader)UnoRuntime.queryInterface(XComponentLoader.class, desktop);
            PropertyValue[] loadProps = new PropertyValue[0];
            XComponent xTextComponent = xComponentLoader.loadComponentFromURL(docLocation, "_blank", 0, loadProps);
        } 
        catch (java.lang.Exception e){
            e.printStackTrace();
        } finally {
            System.exit(0);
        }
    }
    
    public Object getLocalDesktop() throws Exception {
        XComponentContext xRemoteContext = Bootstrap.bootstrap();
        XMultiComponentFactory xRemoteServiceManager = xRemoteContext.getServiceManager();
        Object desktop = xRemoteServiceManager.createInstanceWithContext("com.sun.star.frame.Desktop", xRemoteContext);
        return desktop;
    }

    public Object remoteConnect(String host, String port) throws Exception {
        XComponentContext xLocalContext = com.sun.star.comp.helper.Bootstrap.createInitialComponentContext(null);
        XMultiComponentFactory xLocalServiceManager = xLocalContext.getServiceManager();
        Object urlResolver = xLocalServiceManager.createInstanceWithContext("com.sun.star.bridge.UnoUrlResolver", xLocalContext);
        XUnoUrlResolver xUrlResolver = (XUnoUrlResolver) UnoRuntime.queryInterface(XUnoUrlResolver.class, urlResolver);
        Object initialObject = xUrlResolver.resolve("uno:socket,host=" + host + ",port=" + port + ";urp;StarOffice.ServiceManager");
        XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, initialObject);
        Object context = xPropertySet.getPropertyValue("DefaultContext");
        XComponentContext xRemoteContext = (XComponentContext)UnoRuntime.queryInterface(XComponentContext.class, context);
        XMultiComponentFactory mxRemoteServiceManager = xRemoteContext.getServiceManager();
        Object desktop = mxRemoteServiceManager.createInstanceWithContext("com.sun.star.frame.Desktop", null);
        return desktop;
    }
}
