/*
 * PresentationFileFilter.java
 *
 * Created on 14 juni 2006, 21:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package nl.reeven.van.nljug.presentation;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 *
 * @author wouter_r
 */
public class PresentationFileFilter extends FileFilter {
    
    /** Creates a new instance of PresentationFileFilter */
    public PresentationFileFilter() {
    }

    public boolean accept(File pathname) {
        if (pathname.isDirectory()) {
            return true;
        }
        
        String extension = null;
        String s = pathname.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            extension = s.substring(i+1).toLowerCase();
        }
        if (extension != null) {
            if (extension.equals("otp") ||
                extension.equals("ppt")) {
                    return true;
            } else {
                return false;
            }
        }
        return false;
    }

    public String getDescription() {
        return "All presentation templates.";
    }
    
}
